namespace MyRM
{
   class MyRM : System.MarshalByRefObject, TP.RM
	{
		MyLM lockManager;
		TP.TM transactionManager;
		System.Collections.Hashtable Items;
	        System.Collections.Hashtable Reservations;
		
		public MyRM()
		{
			System.Console.WriteLine( "Resourse Manager Instaniated" );
			this.lockManager = new MyLM();
			this.transactionManager = (TP.TM) System.Activator.GetObject( typeof( MyTM.MyTM ), "http://localhost:8081/TM.soap");
			TP.Transaction tid = transactionManager.Start();
			transactionManager.Abort( tid );
			Items = new System.Collections.Hashtable();
			Reservations = new System.Collections.Hashtable();
		}

		class Reservation
		{
			public TP.Customer Holder;
			public System.Collections.ArrayList Items;
			public Reservation( TP.Customer c, TP.Item i, int price )
			{
				this.Holder = c;
				Items = new System.Collections.ArrayList();
				Items.Add( new ItemReservation( i, price ));
			}
		}

		class ItemReservation
		{
			public TP.Item ThisItem;
			public int Price;
			public ItemReservation( TP.Item i, int price)
		   {
			   this.ThisItem=i;
			   Price = price;
		   }
   	        }

		class  ItemInstance
		{
			string Name
			{
				get
				{
					return i.Name;
				}
			}
			TP.Item i;
			public int Count;
			public int CurrentPrice;
			public ItemInstance( TP.Item i, int count, int price )
			{
				this.i = i;
				this.Count = count;
				this.CurrentPrice = price;
			}
		}

		static void Main( string [] args )
		{
			System.Console.WriteLine( string.Format( "Starting resource manager for {0} on port {1}", args[0], args[1] ));
			System.Threading.Thread.Sleep( 4000 ); // Wait for Transaction manager to come up
			System.Runtime.Remoting.Channels.HTTP.HTTPChannel channel = new System.Runtime.Remoting.Channels.HTTP.HTTPChannel( args[1].ToInt32() );
			System.Runtime.Remoting.ChannelServices.RegisterChannel( channel );
			System.Runtime.Remoting.RemotingServices.RegisterWellKnownType
			(	"MyRM"							// assembly name
			,	"MyRM.MyRM"				// full type name
			,	"RM.soap"							//URI
			,	System.Runtime.Remoting.WellKnownObjectMode.Singleton	// instancing mode
			);
			while( true )
				System.Threading.Thread.Sleep( 100000 );

		}

		public void Enlist( TP.Transaction context )
		{
			transactionManager.Enlist( context );
		}

		public void Commit( TP.Transaction context )
		{
			transactionManager.Commit( context );
		}

		public void Abort( TP.Transaction context )
		{
			transactionManager.Abort( context );
		}

		public void Add( TP.Transaction context, TP.Item i, int count, int price)
		{
			ItemInstance ii = (ItemInstance)Items[i.Name];
			if( ii != null )
			{
				ii.Count += count;
				ii.CurrentPrice = price;
			}
			else
				Items.Add( i.Name, new ItemInstance( i, count, price ) );
		}

		public void Delete( TP.Transaction context, TP.Item i )
		{
			Items.Remove( i.Name );
		}

		public void Shutdown()
		{
		}

		public void SelfDestruct(int diskWritesToWait)
		{
		}

		public int Query( TP.Transaction context, TP.Item i )
		{
			ItemInstance ii = (ItemInstance) Items[i.Name];
			if( ii == null )
				return 0;
			else
				return ii.Count;
		}

		public int QueryPrice( TP.Transaction xId, TP.Item i )
		{
			return ((ItemInstance)Items[i.Name]).CurrentPrice;
		}

		public string QueryCustomer( TP.Transaction context, TP.Customer c )
		{
			string order;
			order = "";
			Reservation r = (Reservation) Reservations[c.Id];
			foreach( ItemReservation rr in r.Items )
			{
				if( order.Length > 0 )
					order += ",";
				order += rr.ThisItem.Name;
			}
			return order;
		}

		public int Reserve( TP.Transaction context, TP.Customer c, TP.Item i )
		{
			ItemInstance ii = (ItemInstance)Items[i.Name];
			if( ii == null)
				throw new System.Exception( string.Format( "Item {0} does not exists", i.Name));
			if( ii.Count > 0 )
			{
				Reservation r = (Reservation)Reservations[c.Id];
				if( r == null ) 
				{
					r = new Reservation( c, i, ii.CurrentPrice );
					Reservations.Add( c.Id, r );					
				}
				ii.Count -= 1;
				return ii.CurrentPrice;
			}
			else
				throw new System.Exception( "No more items available" );
		}

		public void DropReservations( TP.Transaction context, TP.Customer c )
		{
			Reservation r = (Reservation) Reservations[c.Id];
			foreach( ItemReservation rr in r.Items )
				((ItemInstance)Items[rr.ThisItem]).Count += 1;
			Reservations.Remove(c.Id);
		}
	}
}
