namespace MyWC
{
	class MyWC : TP.WC
	{
		static TP.RM Flights;
		static TP.RM Rooms;
		static TP.RM Cars;
		static TP.TM TransactionManager;

		public int ReserveItinerary( TP.Customer c, string [] flights, string location, bool car, bool room )
		{
			int price = 0;
			TP.Transaction tid = TransactionManager.Start();
			try
			{
				if( car )
					price += Cars.Reserve( tid, c, new TP.Item( location ));
				if( room )
					price += Rooms.Reserve( tid, c, new TP.Item( location ));
				foreach( string flight in flights )
					price += Flights.Reserve( tid, c, new TP.Item( flight ));
				Cars.Commit( tid );
				Flights.Commit( tid );
				Rooms.Commit( tid );
			}
			catch( System.Exception e )
			{
				Cars.Abort( tid );
				Flights.Abort( tid );
				Rooms.Abort( tid );
				price = 0;
				throw e;
			}
			return price;
		}

		static void Main( string [] args )
		{
			int price;
			System.Runtime.Remoting.ChannelServices.RegisterChannel( new System.Runtime.Remoting.Channels.HTTP.HTTPChannel());
			TransactionManager  = (TP.TM) System.Activator.GetObject( typeof( TP.TM ), "http://localhost:8081/TM.soap");
			Flights = (TP.RM) System.Activator.GetObject( typeof( TP.RM ), "http://localhost:8082/RM.soap");
			Rooms = (TP.RM) System.Activator.GetObject( typeof( TP.RM ), "http://localhost:8083/RM.soap");
			Cars = (TP.RM) System.Activator.GetObject( typeof( TP.RM ), "http://localhost:8084/RM.soap");
			TP.WC WC= new MyWC();
			try
			{
				price = WC.ReserveItinerary( new TP.Customer(), new  string[]{ "Seattle-Chicago", "Chicago-Boston" }, "Boston", true, true );
				System.Console.WriteLine( string.Format("Itinerary booked for {0} dollar", price ));
			}
			catch( System.Exception e )
			{
				System.Console.WriteLine( string.Format( "Reservation failed: {0}", e ));
			}
			Flights.Add( null, new TP.Item("Seattle-Chicago"), 100, 1000 );
			Flights.Add( null, new TP.Item( "Chicago-Boston"), 100, 1000 );
			Rooms.Add( null, new TP.Item( "Boston" ), 100, 200 );
			Cars.Add( null, new TP.Item( "Boston" ), 100, 200 );
			price = WC.ReserveItinerary( new TP.Customer(), new  string[]{ "Seattle-Chicago", "Chicago-Boston" }, "Boston", true, true );
			System.Console.WriteLine( string.Format( "Itinerary booked for {0} dollar", price ));
		}
	}
}
