namespace TP
{
	public class Transaction
	{
		public System.Guid Id;
		public Transaction()
		{
			this.Id = System.Guid.NewGuid();
		}

	}

	public class Customer
	{
		public System.Guid Id;
		public Customer()
		{
			this.Id = new System.Guid();
		}
	}

	public class Item
	{
		public string Name;
		public Item( string name )
		{
			this.Name = name;
		}
	}

	public interface RS
	{
	}

	public interface LM
	{
		void LockForRead( Transaction context, RS resource);
		void LockForWrite( Transaction context, RS resource);
		void UnlockRead( Transaction context, RS resource );
		void UnlockWrite( Transaction context, RS resource );
		void UnlockAll( Transaction context );
	}

	public interface TM
	{
		Transaction  Start();
		void Commit( Transaction context );
		void Abort( Transaction context );
		void Enlist( Transaction context );
	}

	public interface WC
	{
		int ReserveItinerary( TP.Customer c, string [] flights, string location, bool car, bool room );
	}

	public interface RM
	{
	// Transaction Boundaries
		void Enlist( Transaction context );
		void Commit( Transaction context );
		void Abort( Transaction context );
	// Populate Database
		void Add( Transaction context, Item i, int count, int price );
		void Delete( Transaction context, Item i );
	// Query
		int Query( Transaction context, Item i );
		int QueryPrice( Transaction context, Item i );
		string QueryCustomer( Transaction context, Customer c );
	// Reservation
		int Reserve( Transaction context, Customer c, Item i ); // returns price
		void DropReservations( Transaction context, Customer c );
		
	//
	// technical/testing interface
	//

	/** Shutdown gracefully.
	* When this RM restarts, it should not attempt to recover its state if
	* the client called shutdown to terminate it.
	*/
		void Shutdown();

	/** Call exit after a specified number of disk writes.
	* Support for this method requires a wrapper around the system's 
	* write to disk command that decrements the counter set by this method.
	* This counter should default to 0, which implies that the wrapper
	* will do nothing.  If the count is non-zero, the wrapper should decrement
	* the counter, see if it becomes zero, and if so, call exit(), otherwise
	* continue the write.
	*
	* This method is not part of a transaction.
	*/
		void SelfDestruct(int diskWritesToWait);
	}
}