public class TestMyLM
{
	static MyRM.MyLM lockManager = new MyRM.MyLM();
	class MyRS : TP.RS
	{
		public MyRS( string name )
		{
			this.name = name;
		}
		public override int GetHashCode()
		{
			return this.name.GetHashCode();
		}
		public override bool Equals( object o )
		{
			return this.name.Equals( ((MyRS) o).name );
		}
		public override string ToString()
		{
			return this.name;
		}
		string name;
	}
	 static void StartThread1()
	{
		TP.Transaction tid = new TP.Transaction();
		lockManager.LockForWrite( tid, new MyRS( "chicago-london" ));
		System.Console.WriteLine( "chicago-london locked" );
		System.Threading.Thread.Sleep( 2000 );
		lockManager.UnlockWrite( tid, new MyRS( "chicago-london" ));
	}
    public static void Main(string[] args)
    {
		TP.Transaction t1 = new TP.Transaction();
		TP.Transaction t2 = new TP.Transaction();
		lockManager.LockForRead( t1, new MyRS( "chicago-london" ));
		lockManager.LockForRead( t2, new MyRS( "chicago-london" ));
		try
		{
			lockManager.LockForWrite( t1, new MyRS( "chicago-london" ));
			throw new System.Exception( "internal error" );
		}
		catch( MyRM.MyLM.DeadLockDetected e )
		{
			System.Console.WriteLine( e.Message );
		}
		try
		{
			lockManager.LockForWrite( t2, new MyRS( "chicago-london" ));
			throw new System.Exception( "internal error" );
		}
		catch( MyRM.MyLM.DeadLockDetected e )
		{
			System.Console.WriteLine( e.Message );
		}
		lockManager.UnlockRead( t1, new MyRS( "chicago-london" ));
		lockManager.UnlockRead( t2, new MyRS( "chicago-london" ));
		lockManager.LockForWrite( t1, new MyRS( "chicago-london" ));
		try
		{
			lockManager.LockForWrite( t2, new MyRS( "chicago-london" ));
			throw new System.Exception( "internal error" );
		}
		catch( MyRM.MyLM.DeadLockDetected e )
		{
			System.Console.WriteLine( e.Message );
		}
		lockManager.UnlockWrite( t1, new MyRS( "chicago-london" ));
		System.Console.WriteLine( "Start multithreaded test" );
		System.Threading.Thread User1 = new System.Threading.Thread( new System.Threading.ThreadStart( StartThread1 ));
		System.Threading.Thread User2 = new System.Threading.Thread( new System.Threading.ThreadStart( StartThread1 ));
		User1.Start();
		User2.Start();
	}
}
